EnableExplicit

#ctSSLayer_CompiledFeature_NoNeedUnicodeConversion_AtoW = 0
#ctSSLayer_CompiledFeature_NoNeedUnicodeConversion_WtoA = 1

#ctSSLayer_CompiledFeature_ReadTagsA = 1
#ctSSLayer_CompiledFeature_ReadTagsW = 1
;#ctSSLayer_CompiledFeature_ReadTags = #ctSSLayer_CompiledFeature_ReadTagsA | #ctSSLayer_CompiledFeature_ReadTagsW

#ctSSLayer_CompiledFeature_LoadSongA = 1
#ctSSLayer_CompiledFeature_LoadSongW = 1

#ctSSLayer_CompiledFeature_ManualDeviceSelect = 1
#ctSSLayer_CompiledFeature_GetDeviceNameA = 1 & #ctSSLayer_CompiledFeature_ManualDeviceSelect
#ctSSLayer_CompiledFeature_GetDeviceNameW = 1 & #ctSSLayer_CompiledFeature_ManualDeviceSelect

#ctSSLayer_CompiledFeature_GetInfoStringA = 1
#ctSSLayer_CompiledFeature_GetInfoStringW = 1

#ctSSLayer_CompiledFeature_MusicPatternBased = 0;2

#ctSSLayer_CompiledFeature_Spectrum = 1

#ctSSLayer_CompiledFeature_CD_AndOr_CDDA = 0 ;1

#ctSSLayer_CompiledFeature_EndCallBack = 1

#ctSSLayer_CompiledFeature_InetStreams = 1

#ctSSLayer_SpectrumArrayCount = 32

XIncludeFile "ctSSLayer_Common00.pb"








; Copyright (C) 2002-2008 Jan Vorel
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.

; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

; If you have any questions, suggestions or bug reports about this product,
; contact me: info@ctuser.net; Do not contact me about general B.A.S.I.C.
; language or A.P.I. issues

ProcedureDLL AttachProcess(Instance)
  #VersionID = $10000610
  #VersionIDF = "1.00 beta 61"

  Structure DSBCAPS 
    dwSize.l 
    dwFlags.l 
    dwBufferBytes.l 
    dwUnlockTransferRate.l 
    dwPlayCpuOverhead.l 
    EndStructure 
  
  Global InfoString.s
  CompilerIf #ctSSLayer_CompiledFeature_NoNeedUnicodeConversion_AtoW = 0
    Global InfoStringW.l
    CompilerEndIf
  
  #KeepAliveTime = 1000
  #ctSSLayer_MaxIDs = 16
  #ctSSLayer_MaxIDsX = #ctSSLayer_MaxIDs - 1
  
  
  Global VersionID.l
  CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Global IsCDing.l
    CompilerEndIf

  ;Global WMAUsable.l

  
  Structure tSong
    mode.l
    Pointer.l
    ;ExtraA.l ;channel or driveletter
    CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
      ;CDTrackID.l
      CompilerEndIf
    Size.l
    CompilerIf #ctSSLayer_CompiledFeature_ReadTags
      ;Format_QualityMulti.f
      CompilerEndIf
    CurVolume.l
    IsPaused.l
    LastPosition.l
    EndStructure


  Structure QPSongInfoStructLite
    FormatOK.l ;bool
    Format_Frequency.l
    Format_BitRate.l
    Format_Channels.l
    Format_VBR.l ;bool
    Format_QualityMulti.l
    TagOK.l ;bool
    EndStructure

  
  Global *MemStrConv
  *MemStrConv = AllocateMemory(1024)
  Global xSysPath.s
  CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
    CompilerEndIf
  CompilerIf #ctSSLayer_CompiledFeature_Spectrum
    CompilerEndIf
  CompilerIf #ctSSLayer_CompiledFeature_ReadTags
    CompilerEndIf
  CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    CompilerEndIf
 
  Global *hKernel
  Global *hKernelShortPN

  CompilerIf #ctSSLayer_CompiledFeature_EndCallBack
    CompilerEndIf

  *hKernel = OpenLibrary(#PB_Any, "kernel32.dll")
  If *hKernel
    *hKernelShortPN = GetFunction(*hKernel, "GetShortPathNameW")
    If *hKernelShortPN = 0
      CloseLibrary(*hKernel)
      EndIf
    EndIf
  EndProcedure

XIncludeFile "ctSSLayer_Common01.pb"

ProcedureDLL DetachProcess(Instance)
  If *hKernelShortPN
    CloseLibrary(*hKernel)
    EndIf
  EndProcedure

ProcedureDLL AttachThread(Instance)
  EndProcedure

ProcedureDLL DetachThread(Instance)
  EndProcedure

ProcedureDLL.l ctSSLayer_CanUseItem(Index.l)
  Define.l Result

  Select Index
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    ;Case 0 ; cdda   (force off / force on / user choses)
    ;Case 1 ; jitter   (force off / force on / user choses)
    ;Case 2 ; runtimecdda/jitter update   (disabled=requires ReInit of soundsystem / available)
    ;  Result = 1
CompilerEndIf
;    Case 3 ; checkaccuratestreams   (force off / force on / user choses)
;      Result = 0
    
CompilerIf #ctSSLayer_CompiledFeature_Spectrum
;    Case 4 ; UseSpectrum   (disabled / available)
CompilerEndIf
;;;    ;Case 5 ; UseGetCDDtracks   (disabled / available)
    Case 6 ; ModuleTimeHandling:             ;getp/Len (For seeking!!)
      ; 1 = Patterns (or patterncheck needed) (pat/pat)
      Result = 1
    Case 7 ; maxDeviceCount
      Result = 1
    ;Case 9 ; MidiXFade   (disabled / available)
      ;Result = 0
    
    
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Case $A ; SupportsCD or CDDA (0/1)
      Result = 1
CompilerEndIf
    Case $C ; KeepAliveTime: leave channel stopped before unloading (buffer!)
      Result = #KeepAliveTime
    Case $D      ;#ctSSLayer_MaxIDs ; for future use, currently fixed
      Result = #ctSSLayer_MaxIDs
CompilerIf #ctSSLayer_CompiledFeature_EndCallBack
;    Case $10 ; EndCallback; 1 = partial, 2 = full
CompilerEndIf
;    Case $11 ; Internet/streams; 1 = yes!

    Case $20
      ;  < 20 = ok

      ;    20 (DirectX missing)
      ;    21 (DirectX to old (or missing))
      ;    90 = cannot load (generic something missing)
      ;         should have high priority!
      Result = VersionID
    EndSelect
  
  ProcedureReturn Result
  EndProcedure

ProcedureDLL ctSSLayer_Close(Fast.l)
  If Fast = 0
    Sleep_(#KeepAliveTime + 500)
    EndIf
  CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    If IsCDing
      EndIf
    CompilerEndIf  
  EndProcedure


Procedure _DirectSoundCB(Guid, desc, module, context) 
  CopyMemory(desc, context, 256) 
  ProcedureReturn 0 
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_GetDeviceNameA
  ProcedureDLL.l ctSSLayer_GetDeviceNameA(DeviceID.l, *Flags)
    If *Flags
      PokeL(*Flags, 1)
      EndIf

    Define.l xLong1 = GetModuleHandle_("dsound.dll") 
    If xLong1
      xLong1 = GetProcAddress_(xLong1, "DirectSoundEnumerateA")
      If xLong1
        InfoString = Space(256)
        CallFunctionFast(xLong1, @_DirectSoundCB(), InfoString)
        ProcedureReturn @InfoString
        EndIf
      EndIf

    ProcedureReturn 0 ;@InfoString
    EndProcedure
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_GetInfoStringA
ProcedureDLL.l ctSSLayer_GetInfoStringA(Index.l)
CompilerElse
Procedure.l ctSSLayer_GetInfoStringA(Index.l)
CompilerEndIf
  InfoString = ""
  
  Select Index
    Case 0 ; ShortName
      InfoString = "PBNative"
    Case 1 ; FullName
      InfoString = "Purebasic powered sound system"
    Case 2 ; DllName
      InfoString = ""
    Case 4 ; Unique dll/versions string
      InfoString = "PBNative_" + Hex(#VersionID)
    



    Case 16 ; StreamsAll
      InfoString = "ogg;flac;";???
CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
    Case 17 ; TrackerAllbutMidi
      InfoString = "mod,it,xm,s3m;oxm;";???
    Case 18 ; Midi
      InfoString = "mid,midi;rmi,sgt;";???
CompilerEndIf
    Case 25 ; AllDef
      InfoString = "ogg;"
    Case $30
      InfoString = #VersionIDF
    Case $31 ; required dll files; seperate with ;!
      InfoString = "msvcrt.dll"
    Case $40 ; homepage URL
      InfoString = "http://www.ctuser.net"
    Default
      ProcedureReturn 0
    EndSelect
  ProcedureReturn @InfoString

CompilerIf #ctSSLayer_CompiledFeature_GetInfoStringA ; for PB IDE folding feature
  EndProcedure                                       ; for PB IDE folding feature
CompilerElse                                         ; for PB IDE folding feature
  EndProcedure                                       ; for PB IDE folding feature
CompilerEndIf                                        ; for PB IDE folding feature

CompilerIf 0                                         ; for enlisting in current project, real procedure in common file
  ProcedureDLL.l ctSSLayer_GetInfoStringW(Index.l)   ; for enlisting in current project, real procedure in common file
    EndProcedure                                     ; for enlisting in current project, real procedure in common file
  CompilerEndIf                                      ; for enlisting in current project, real procedure in common file

ProcedureDLL.l ctSSLayer_GetPosition(*SongPointer.tSong)
  Define.l Result

  Select *SongPointer\mode
    Case #ctSSLayer_MusicTypeStream
      Define *DSB.IDirectSoundBuffer=PeekL(IsSound(*SongPointer\Pointer)) 
      *DSB\GetCurrentPosition(@Result,0) 

CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
    Case #ctSSLayer_MusicTypeTracker
      If *SongPointer\IsPaused
        Result = *SongPointer\LastPosition
        Else
        Result = CallFunctionFast(*FMUSIC_GetOrder, *SongPointer\Pointer)
        EndIf
CompilerEndIf
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Case #ctSSLayer_MusicTypeCDAudio
      If *SongPointer\IsPaused
        Result = *SongPointer\LastPosition
        ElseIf VersionID > 35999
        Result = CallFunctionFast(*FSOUND_CD_GetTrackTime, *SongPointer\ExtraA)
        Else
        Result = CallFunctionFast(*FSOUND_CD_GetTrackTime)
        EndIf
CompilerEndIf
    EndSelect
  ProcedureReturn Result
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_Spectrum
  ProcedureDLL ctSSLayer_GetSpectrum(*xSingleA1, ArraySize.l, *SongPointer.tSong, Stereo.l)
    EndProcedure
  CompilerEndIf

ProcedureDLL.l ctSSLayer_Init(OutputDevice.l, MainHWnd.l, UseCDDA.l, UseJitterCorrection.l)
  If InitSound()
    UseOGGSoundDecoder()
    UseFLACSoundDecoder()
    ProcedureReturn 1
    EndIf
  EndProcedure

; Continues LoadSong
CompilerIf #ctSSLayer_CompiledFeature_LoadSongA
  ProcedureDLL.l ctSSLayer_LoadSongA(mode.l, *Filename, CheckAccurate.l)
  CompilerElse
  Procedure.l ctSSLayer_LoadSongA(mode.l, *Filename, CheckAccurate.l)
  CompilerEndIf

  Define *SongPointer.tSong = AllocateMemory(SizeOf(tSong))
  Define.s FilenameAnsi = PeekS(*Filename)
  
  
  Select mode
CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
    Case #ctSSLayer_MusicTypeTracker
      *SongPointer\Pointer = CallFunctionFast(*FMUSIC_LoadSong, FilenameAnsi)
      If *SongPointer\Pointer
        *SongPointer\Size = CallFunctionFast(*FMUSIC_GetNumOrders, *SongPointer\Pointer)
        EndIf
CompilerEndIf



    Case #ctSSLayer_MusicTypeStream
      *SongPointer\Pointer = LoadSound(#PB_Any, FilenameAnsi, 1);#PB_Sound_Streaming)
      If *SongPointer\Pointer
        Define *DSB.IDirectSoundBuffer=PeekL(IsSound(*SongPointer\Pointer))
        Define Caps.DSBCAPS\dwSize=SizeOf(DSBCAPS) 
        *DSB\GetCaps(@Caps) 
        *SongPointer\Size = Caps\dwBufferBytes 
        EndIf
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Case #ctSSLayer_MusicTypeCDAudio
      Global TempChar.s
      If xUseCDDA ; And ctSSLayer_CanUseItem(0)
        If xUseJitter And ctSSLayer_CanUseItem(1)
          TempChar = LCase(Left(FilenameAnsi, 2))
          *SongPointer\Pointer = CallFunctionFast(*FSOUND_Stream_Open, TempChar, 0, 0, 0)
          Else
          TempChar = LCase(Left(FilenameAnsi, 2)) + "*j"
          *SongPointer\Pointer = CallFunctionFast(*FSOUND_Stream_Open, TempChar, 0, 0, 0)
          EndIf
        If *SongPointer\Pointer
          If (CallFunctionFast(*FSOUND_Stream_SetSubStream, *SongPointer\Pointer, Val(GetTrackNumber(FilenameAnsi)) - 1) & $ff)
            *SongPointer\Size = CallFunctionFast(*FSOUND_Stream_GetLengthMs, *SongPointer\Pointer)
            Else
            CallFunctionFast(*FSOUND_Stream_Close, *SongPointer\Pointer)
            *SongPointer\Pointer = 0
            EndIf
          EndIf
        mode = #ctSSLayer_MusicTypeStream
        Else
        *SongPointer\CDTrackID = Val(GetTrackNumber(FilenameAnsi))
        If VersionID > 35999
          *SongPointer\ExtraA = Asc(Left(FilenameAnsi, 1))
          *SongPointer\Size = CallFunctionFast(*FSOUND_CD_GetTrackLength, *SongPointer\ExtraA, *SongPointer\CDTrackID)
          If *SongPointer\Size
            *SongPointer\Pointer = 1
            ;IsCDing = 1
            EndIf
          Else
          *SongPointer\CDTrackID - 1
          *SongPointer\Size = CallFunctionFast(*FSOUND_CD_GetTrackLength, *SongPointer\CDTrackID)
          If *SongPointer\Size
            *SongPointer\Pointer = 1
            ;IsCDing = 1
            EndIf
          EndIf
        EndIf
CompilerEndIf
    EndSelect
  
  If *SongPointer\Pointer
    *SongPointer\mode = mode
    If *SongPointer\Size = 0
      *SongPointer\Size = 1
      EndIf
    ProcedureReturn *SongPointer
    Else
    FreeMemory(*SongPointer)
    EndIf
  ;DoClearError()
CompilerIf #ctSSLayer_CompiledFeature_LoadSongA ; for PB IDE folding feature
  EndProcedure                                  ; for PB IDE folding feature
CompilerElse                                    ; for PB IDE folding feature
  EndProcedure                                  ; for PB IDE folding feature
CompilerEndIf                                   ; for PB IDE folding feature

CompilerIf #ctSSLayer_CompiledFeature_LoadSongA & #ctSSLayer_CompiledFeature_LoadSongW
  ProcedureDLL.l ctSSLayer_LoadSongW(mode.l, *Filename, CheckAccurate.l)
    Define.s xChar1 = PeekS(*Filename, -1, #PB_Unicode)
    
    If *hKernelShortPN
      Define.l xLong1 = AllocateMemory(516)
      If xLong1
        Define.l xLong2
        xLong2 = CallFunctionFast(*hKernelShortPN, *Filename, xLong1, 257)
        If xLong2 And (xLong2 < 257)
          xChar1 = PeekS(xLong1, xLong2, #PB_Unicode)
          EndIf
        FreeMemory(xLong2)
        EndIf
      EndIf
    ProcedureReturn ctSSLayer_LoadSongA(mode, @xChar1, CheckAccurate)
    EndProcedure
  CompilerEndIf

ProcedureDLL ctSSLayer_LoadSongAbort(*SongPointer.tSong)
  Select *SongPointer\mode
    Case #ctSSLayer_MusicTypeStream
      FreeSound(*SongPointer\Pointer)
CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
    Case #ctSSLayer_MusicTypeTracker
      CallFunctionFast(*FMUSIC_FreeSong, *SongPointer\Pointer)
CompilerEndIf
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
;    Case #ctSSLayer_MusicTypeCDAudio
      ;If IsCDing
      ;  If VersionID > 35999
      ;    CallFunctionFast(*FSOUND_CD_Stop, *SongPointer\ExtraA)
      ;    Else
      ;    CallFunctionFast(*FSOUND_CD_Stop)
      ;    EndIf
      ;  IsCDing = 0
      ;; EndIf
CompilerEndIf
    EndSelect
  FreeMemory(*SongPointer)
  EndProcedure

; Continues LoadSong
ProcedureDLL.l ctSSLayer_LoadSongPlay(*SongPointer.tSong, Volume.l, LoopSong.l, Panning.l, Paused.l)
  Define.b xByte1
  ;*SongPointer\CurPan = Panning
  *SongPointer\LastPosition = 0
  *SongPointer\CurVolume = Volume
  *SongPointer\IsPaused = Paused
  
  Select *SongPointer\mode
    Case #ctSSLayer_MusicTypeStream
      If Paused = 0
        SoundVolume(*SongPointer\Pointer, Volume / 2.55)
        PlaySound(*SongPointer\Pointer, 0)
        SoundVolume(*SongPointer\Pointer, Volume / 2.55)
        EndIf
      ProcedureReturn 1
      
CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
    Case #ctSSLayer_MusicTypeTracker
      If VersionID < 37000
        If VersionID > 35999
          MUSICSetLooping(*SongPointer\Pointer, 0)
          EndIf
        Else
        MUSICSetLooping(*SongPointer\Pointer, xByte1)
        EndIf
      CallFunctionFast(*FMUSIC_SetMasterVolume, *SongPointer\Pointer, Volume)
      MUSICSetPanSeperation(*SongPointer\Pointer, Panning / 100)
      CallFunctionFast(*FMUSIC_PlaySong, *SongPointer\Pointer)
      CallFunctionFast(*FMUSIC_SetMasterVolume, *SongPointer\Pointer, Volume)
      If Paused
        CallFunctionFast(*FMUSIC_SetPaused, *SongPointer\Pointer, -1) ;true!
        EndIf
      MUSICSetPanSeperation(*SongPointer\Pointer, Panning / 100)
      If VersionID < 37000
        If VersionID > 35999
          xByte1.b
          If LoopSong
            xByte1 = 1
            EndIf
          MUSICSetLooping(*SongPointer\Pointer, xByte1)
          EndIf
        Else
        If LoopSong
          xByte1 = 1
          EndIf
        MUSICSetLooping(*SongPointer\Pointer, xByte1)
        EndIf
      ProcedureReturn 1
CompilerEndIf
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Case #ctSSLayer_MusicTypeCDAudio
      If VersionID > 35999
        CallFunctionFast(*FSOUND_CD_SetVolume, *SongPointer\ExtraA, Volume)
        CallFunctionFast(*FSOUND_CD_SetPlayMode, *SongPointer\ExtraA, 1)
        CallFunctionFast(*FSOUND_CD_Play, *SongPointer\ExtraA, *SongPointer\CDTrackID)
        If Paused
          CallFunctionFast(*FSOUND_SetPaused, *SongPointer\ExtraA, 1)
          EndIf
        CallFunctionFast(*FSOUND_CD_SetVolume, *SongPointer\ExtraA, Volume)
        CallFunctionFast(*FSOUND_CD_SetPlayMode, *SongPointer\ExtraA, 1)
        IsCDing = *SongPointer\ExtraA
        Else
        CallFunctionFast(*FSOUND_CD_SetVolume, Volume)
        CallFunctionFast(*FSOUND_CD_SetPlayMode, 1)
        CallFunctionFast(*FSOUND_CD_Play, *SongPointer\CDTrackID)
        If Paused
          CallFunctionFast(*FSOUND_SetPaused, 1)
          EndIf
        CallFunctionFast(*FSOUND_CD_SetVolume, Volume)
        CallFunctionFast(*FSOUND_CD_SetPlayMode, 1)
        IsCDing = 1
        EndIf
      ProcedureReturn 1
CompilerEndIf
    EndSelect
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased = 2
  ProcedureDLL.l ctSSLayer_MusicGetPattern(*SongPointer.tSong)
    EndProcedure
  
  ProcedureDLL.l ctSSLayer_MusicGetPatterns(*SongPointer.tSong)
    EndProcedure
  
  ProcedureDLL.l ctSSLayer_MusicHasFinished(*SongPointer.tSong)
    If *SongPointer\mode = #ctSSLayer_MusicTypeTracker
      ProcedureReturn (CallFunctionFast(*FMUSIC_IsFinished, *SongPointer\Pointer) & $ff)
      EndIf
    EndProcedure
  
  ProcedureDLL.l ctSSLayer_MusicTime(*SongPointer.tSong)
  ;  ProcedureReturn CallFunctionFast(*FMUSIC_GetTime, *SongPointer\Pointer)
    EndProcedure
  CompilerEndIf

; First function called, must handle missing dll file
ProcedureDLL.l ctSSLayer_PreInit(EnforceDevice.l, MainHWnd.l)
  If InitSound()
    VersionID = 0
    ProcedureReturn 1
    Else
    VersionID = 21
    EndIf
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_ReadTags
  Procedure.l ctSSLayer_ReadSongInfo(*SongPointer.tSong, *xSongInfo.QPSongInfoStructLite, IsUnicode.l)
    If *xSongInfo
      *xSongInfo\FormatOK = 0
      *xSongInfo\TagOK = 0
      ProcedureReturn 0
      EndIf
    EndProcedure
  
  CompilerIf #ctSSLayer_CompiledFeature_ReadTagsA
    ProcedureDLL.l ctSSLayer_ReadSongInfoA(*SongPointer, *xSongInfo)
      ProcedureReturn ctSSLayer_ReadSongInfo(*SongPointer, *xSongInfo, 0)
      EndProcedure
    CompilerEndIf
  
  CompilerIf #ctSSLayer_CompiledFeature_ReadTagsW
    ProcedureDLL.l ctSSLayer_ReadSongInfoW(*SongPointer, *xSongInfo)
      ProcedureReturn ctSSLayer_ReadSongInfo(*SongPointer, *xSongInfo, 1)
      EndProcedure
    CompilerEndIf
  CompilerEndIf

; Anytime, Position = either time Or pattern And matching size
ProcedureDLL.l ctSSLayer_SeekSong(*SongPointer.tSong, SeekPosition.l)
  Define.l Result
  Define.l xLong1
  Define.l NewPause




  If SeekPosition > -1 And *SongPointer\Size > 0 And SeekPosition < *SongPointer\Size
    ;Result = -1
    Select *SongPointer\mode
CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
      Case #ctSSLayer_MusicTypeTracker
        CallFunctionFast(*FMUSIC_SetMasterVolume, *SongPointer\Pointer, 0)
        If (CallFunctionFast(*FMUSIC_IsFinished, *SongPointer\Pointer) & $ff)
          CallFunctionFast(*FMUSIC_SetMasterVolume, *SongPointer\Pointer, 0)
          CallFunctionFast(*FMUSIC_StopSong, *SongPointer\Pointer)



          NewPause = *SongPointer\IsPaused
          Result = ctSSLayer_LoadSongPlay(*SongPointer, *SongPointer\CurVolume, *SongPointer\CurLoop, *SongPointer\CurPan, 1)
          CallFunctionFast(*FMUSIC_SetOrder, *SongPointer\Pointer, SeekPosition)
          CallFunctionFast(*FMUSIC_SetMasterVolume, *SongPointer\Pointer, *SongPointer\CurVolume)
          If NewPause
            *SongPointer\LastPosition = SeekPosition
            Else
            CallFunctionFast(*FMUSIC_SetPaused, *SongPointer\Pointer, 0)
            *SongPointer\IsPaused = 0
            EndIf
          
          

          Else
          *SongPointer\LastPosition = SeekPosition
          CallFunctionFast(*FMUSIC_SetOrder, *SongPointer\Pointer, SeekPosition)
          CallFunctionFast(*FMUSIC_SetMasterVolume, *SongPointer\Pointer, *SongPointer\CurVolume)
          EndIf
CompilerEndIf
      Case #ctSSLayer_MusicTypeStream
        If *SongPointer\IsPaused
          *SongPointer\LastPosition = SeekPosition
          Else
          Define *DSB.IDirectSoundBuffer=PeekL(IsSound(*SongPointer\Pointer)) 
          Result = *DSB\SetCurrentPosition(SeekPosition)
          EndIf
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
      Case #ctSSLayer_MusicTypeCDAudio
        ;If VersionID > 36100 Or SeekPosition = 0
        If SeekPosition
          If *SongPointer\IsPaused
            xLong1 = *SongPointer\LastPosition
            ElseIf VersionID > 35999
            xLong1 = CallFunctionFast(*FSOUND_CD_GetTrackTime, *SongPointer\ExtraA)
            Else
            xLong1 = CallFunctionFast(*FSOUND_CD_GetTrackTime)
            EndIf
          EndIf
        If VersionID > 35999
          CallFunctionFast(*FSOUND_CD_SetVolume, *SongPointer\ExtraA, 0)
          Else
          CallFunctionFast(*FSOUND_CD_SetVolume, 0)
          EndIf
        If xLong1 = *SongPointer\Size Or SeekPosition = 0
          If VersionID > 35999
            CallFunctionFast(*FSOUND_CD_Stop, *SongPointer\ExtraA)
            If VersionID > 36100
              NewPause = *SongPointer\IsPaused
              Result = ctSSLayer_LoadSongPlay(*SongPointer, *SongPointer\CurVolume, *SongPointer\CurLoop, *SongPointer\CurPan, 1)
              If NewPause
                If VersionID > 36100
                  CallFunctionFast(*FSOUND_CD_SetTrackTime, *SongPointer\ExtraA, SeekPosition)
                  CallFunctionFast(*FSOUND_CD_SetPaused, *SongPointer\ExtraA, 1)
                  *SongPointer\LastPosition = SeekPosition
                  EndIf
                ;*SongPointer\IsPaused = 1
                Else
                CallFunctionFast(*FSOUND_CD_SetPaused, *SongPointer\ExtraA, 0)
                *SongPointer\IsPaused = 0
                EndIf
              Else
              Result = ctSSLayer_LoadSongPlay(*SongPointer, *SongPointer\CurVolume, *SongPointer\CurLoop, *SongPointer\CurPan, *SongPointer\IsPaused)
              *SongPointer\LastPosition = SeekPosition
              EndIf
            Else
            CallFunctionFast(*FSOUND_CD_Stop)
            Result = ctSSLayer_LoadSongPlay(*SongPointer, *SongPointer\CurVolume, *SongPointer\CurLoop, *SongPointer\CurPan, *SongPointer\IsPaused)
            *SongPointer\LastPosition = 0
            EndIf





          ElseIf VersionID > 36100
          CallFunctionFast(*FSOUND_CD_SetTrackTime, *SongPointer\ExtraA, SeekPosition)
          If *SongPointer\IsPaused
            CallFunctionFast(*FSOUND_CD_SetPaused, *SongPointer\ExtraA, 1)
            *SongPointer\LastPosition = SeekPosition
            EndIf
          CallFunctionFast(*FSOUND_CD_SetVolume, *SongPointer\ExtraA, *SongPointer\CurVolume)
          EndIf
CompilerEndIf
      Default
        Result = 0
      EndSelect
    If Result
      Result = 1
      EndIf
    EndIf
  ProcedureReturn Result
  EndProcedure

; Activates callback for HWnd != 0
CompilerIf #ctSSLayer_CompiledFeature_EndCallBack
  ProcedureDLL.l ctSSLayer_SetEndCallback(HWnd.l, Message.l, wParam.l)
    EndProcedure
  CompilerEndIf

ProcedureDLL ctSSLayer_SetPause(*SongPointer.tSong, Pause.l)
  If Not (*SongPointer\IsPaused = Pause)
    *SongPointer\IsPaused = Pause

    Select *SongPointer\mode
      Case #ctSSLayer_MusicTypeStream
        If Pause
          Define *DSB.IDirectSoundBuffer=PeekL(IsSound(*SongPointer\Pointer))
          *DSB\GetCurrentPosition(@*SongPointer\LastPosition,0)
          SoundVolume(*SongPointer\Pointer, 0)
          StopSound(*SongPointer\Pointer)
          Else
          SoundVolume(*SongPointer\Pointer, 0)
          Define *DSB.IDirectSoundBuffer=PeekL(IsSound(*SongPointer\Pointer)) 
          *DSB\SetCurrentPosition(*SongPointer\LastPosition)
          PlaySound(*SongPointer\Pointer)
          SoundVolume(*SongPointer\Pointer, *SongPointer\CurVolume / 2.55)
          EndIf
CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
      Case #ctSSLayer_MusicTypeTracker
        CallFunctionFast(*FMUSIC_SetMasterVolume, *SongPointer\Pointer, *SongPointer\CurVolume)
        ;If Pause
        ;  If Not *SongPointer\IsPaused
  
        CallFunctionFast(*FMUSIC_SetPaused, *SongPointer\Pointer, Pause)
        If Pause
          *SongPointer\LastPosition = CallFunctionFast(*FMUSIC_GetOrder, *SongPointer\Pointer)
          EndIf
        *SongPointer\IsPaused = Pause
CompilerEndIf
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
      Case #ctSSLayer_MusicTypeCDAudio
        ;*SongPointer\IsPaused = Pause
        If VersionID > 35999
          CallFunctionFast(*FSOUND_CD_SetVolume, *SongPointer\ExtraA, *SongPointer\CurVolume)
          If Pause
            If Not *SongPointer\IsPaused
              *SongPointer\LastPosition = CallFunctionFast(*FSOUND_CD_GetTrackTime, *SongPointer\ExtraA)
              EndIf
            CallFunctionFast(*FSOUND_CD_SetPaused, *SongPointer\ExtraA, 1)
            Else
            CallFunctionFast(*FSOUND_CD_SetPaused, *SongPointer\ExtraA, 0)
            EndIf
          Else
          CallFunctionFast(*FSOUND_CD_SetVolume, *SongPointer\CurVolume)
          If Pause
            If Not *SongPointer\IsPaused
              *SongPointer\LastPosition = CallFunctionFast(*FSOUND_CD_GetTrackTime)
              EndIf
            CallFunctionFast(*FSOUND_CD_SetPaused, 1)
            Else
            CallFunctionFast(*FSOUND_CD_SetPaused, 0)
            EndIf
          EndIf
        *SongPointer\IsPaused = Pause
CompilerEndIf
      EndSelect
    EndIf
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_Spectrum
  ProcedureDLL ctSSLayer_SetSpectrum(State.l)
    EndProcedure
  CompilerEndIf

ProcedureDLL ctSSLayer_SetVolume(*SongPointer.tSong, Volume.l)
  *SongPointer\CurVolume = Volume
  Select *SongPointer\mode
CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
    Case #ctSSLayer_MusicTypeTracker
      CallFunctionFast(*FMUSIC_SetMasterVolume, *SongPointer\Pointer, Volume)
CompilerEndIf

    Case #ctSSLayer_MusicTypeStream
      If *SongPointer\IsPaused = 0
        SoundVolume(*SongPointer\Pointer, Volume / 2.55)
        EndIf
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Case #ctSSLayer_MusicTypeCDAudio
      If VersionID > 35999
        CallFunctionFast(*FSOUND_CD_SetVolume, *SongPointer\ExtraA, Volume)
        Else
        CallFunctionFast(*FSOUND_CD_SetVolume, Volume)
        EndIf
CompilerEndIf
    EndSelect
  EndProcedure

ProcedureDLL.l ctSSLayer_SongLength(*SongPointer.tSong)
  ProcedureReturn *SongPointer\Size
  EndProcedure

ProcedureDLL ctSSLayer_UnloadSong(*SongPointer.tSong)
  Select *SongPointer\mode
    Case #ctSSLayer_MusicTypeStream
      If *SongPointer\IsPaused = 0
        SoundVolume(*SongPointer\Pointer, 0)
        StopSound(*SongPointer\Pointer)
        EndIf
      FreeSound(*SongPointer\Pointer)
CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
    Case #ctSSLayer_MusicTypeTracker
      CallFunctionFast(*FMUSIC_SetMasterVolume, *SongPointer\Pointer, 0)
      CallFunctionFast(*FMUSIC_StopSong, *SongPointer\Pointer)
      CallFunctionFast(*FMUSIC_FreeSong, *SongPointer\Pointer)
CompilerEndIf
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Case #ctSSLayer_MusicTypeCDAudio
      If VersionID > 35999
        CallFunctionFast(*FSOUND_CD_SetVolume, *SongPointer\ExtraA, 0)
        CallFunctionFast(*FSOUND_CD_Stop, *SongPointer\ExtraA)
        Else
        CallFunctionFast(*FSOUND_CD_SetVolume, 0)
        CallFunctionFast(*FSOUND_CD_Stop)
        EndIf
      IsCDing = 0
CompilerEndIf
    EndSelect
  FreeMemory(*SongPointer)
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
  ProcedureDLL ctSSLayer_UpdateCDDA(UseCDDA.l, UseJitterCorrection.l)
    xUseCDDA = (UseCDDA And ctSSLayer_CanUseItem(0))
    xUseJitter = UseJitterCorrection And ctSSLayer_CanUseItem(1)
    EndProcedure
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased = 2
  ProcedureDLL ctSSLayer_UpdateLooping(*SongPointer.tSong, LoopSong.l)
    Define.b xByte1
    LoopSong = 0 ;Unsure which version has looping reinit probs
    
    If *SongPointer\mode = #ctSSLayer_MusicTypeTracker
      *SongPointer\CurLoop = LoopSong
      If VersionID < 37000
        If VersionID > 35999
          If LoopSong
            xByte1 = 1
            EndIf
          MUSICSetLooping(*SongPointer\Pointer, xByte1)
          EndIf
        Else
        If LoopSong
          xByte1 = 1
          EndIf
        MUSICSetLooping(*SongPointer\Pointer, xByte1)
        EndIf
      EndIf
    EndProcedure
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
  ProcedureDLL ctSSLayer_UpdatePanning(*SongPointer.tSong, Panning.l)
    If *SongPointer\mode = #ctSSLayer_MusicTypeTracker
      *SongPointer\CurPan = Panning
      MUSICSetPanSeperation(*SongPointer\Pointer, Panning / 100)
      EndIf
    EndProcedure
  CompilerEndIf

ProcedureDLL.l ctSSLayer_Version(OptionalLayerVersionID.l)
  Select OptionalLayerVersionID
    Case 0, $10000682
      ProcedureReturn $10000682
    EndSelect
  EndProcedure




CompilerIf 0
AttachProcess(0)
If ctSSLayer_Version($10000610)
  Debug "1"
  If ctsslayer_preinit(-1, 0)
    ;Debug ctsslayer_canuseitem($20)
    ;Debug ctsslayer_canuseitem($21)
    Debug PeekS(ctsslayer_getinfostringa($1)) + " " + PeekS(ctsslayer_getinfostringa($30))
    ;Debug VersionID
    If ctsslayer_init(0, 0, 1, 0)
      Debug "inited"
      ;Define.l xLong1 = ctsslayer_loadsonga(#ctSSLayer_MusicTypeCDAudio, @"r:\track01.cda", 1)
      Define.l xLong1 = ctsslayer_loadsonga(#ctSSLayer_MusicTypeInetStream, @"http://87.118.96.189:8050", 1)
      If xLong1
        Debug "loadok"
        Delay(2000)
        Debug ctsslayer_loadsongplay(xLong1, 255, 0, 80, 0)
        ;Repeat
        ;  Delay(100)
        ;  ForEver
        Delay(20000)
        EndIf
      EndIf
    EndIf
  EndIf

DetachProcess(0)
CompilerEndIf

XIncludeFile "ctSSLayer_Common02.pb"










CompilerIf 0

Structure DSBCAPS 
 dwSize.l 
 dwFlags.l 
 dwBufferBytes.l 
 dwUnlockTransferRate.l 
 dwPlayCpuOverhead.l 
EndStructure 

Procedure _DirectSoundCB(guid,desc,module,context) 
 CopyMemory(desc,context,256) 
 ProcedureReturn 0 
EndProcedure 

Procedure IsSoundPlaying(Sound);returns weather the Sound is playing or not. 
 Address=IsSound(Sound) 
 If Address=0:ProcedureReturn 0:EndIf 
 *DSB.IDirectSoundBuffer=PeekL(Address) 
 *DSB\GetStatus(@Status) 
 If Status=1 Or Status=5 
  ProcedureReturn 1 
 EndIf 
 ProcedureReturn 0 
EndProcedure 

Procedure GetSoundPosition(Sound);returns the current position of the Sound.(in bytes) 
 Address=IsSound(Sound) 
 If Address=0:ProcedureReturn 0:EndIf 
 *DSB.IDirectSoundBuffer=PeekL(Address) 
 *DSB\GetCurrentPosition(@Position,0) 
 ProcedureReturn Position
EndProcedure 

Procedure SetSoundPosition(Sound,Position);sets the current position of the Sound.(in bytes) 
 Address=IsSound(Sound) 
 If Address=0:ProcedureReturn 0:EndIf 
 *DSB.IDirectSoundBuffer=PeekL(Address) 
 ProcedureReturn *DSB\SetCurrentPosition(Position) 
EndProcedure 

Procedure GetSoundSize(Sound);Returns the size of the Sound in bytes. 
 Address=IsSound(Sound) 
 If Address=0:ProcedureReturn 0:EndIf 
 *DSB.IDirectSoundBuffer=PeekL(Address) 
 Caps.DSBCAPS\dwSize=SizeOf(DSBCAPS) 
 *DSB\GetCaps(@Caps) 
 ProcedureReturn Caps\dwBufferBytes 
EndProcedure 

Procedure GetSoundFrequency(Sound) 
 Address=IsSound(Sound) 
 If Address=0:ProcedureReturn 0:EndIf 
 *DSB.IDirectSoundBuffer=PeekL(Address) 
 *DSB\GetFrequency(@Freq) 
 ProcedureReturn Freq 
EndProcedure 

Procedure.s GetSoundCardName() 
 hModule=GetModuleHandle_("dsound.dll") 
 If hModule=0:ProcedureReturn "":EndIf 
 Addr=GetProcAddress_(hModule,"DirectSoundEnumerateA") 
 If Addr=0:ProcedureReturn "":EndIf 
 String$=Space(256) 
 CallFunctionFast(Addr,@_DirectSoundCB(),String$) 
 ProcedureReturn String$ 
EndProcedure 
CompilerEndIf

; IDE Options = PureBasic 4.31 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 883
; FirstLine = 879
; Folding = -----------------